Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MIE.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MIE.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MIE.pm	(revision 34921)
@@ -15,5 +15,5 @@
 use Image::ExifTool::GPS;
 
-$VERSION = '1.34';
+$VERSION = '1.48';
 
 sub ProcessMIE($$);
@@ -144,5 +144,5 @@
         C<TAG-xx_YY>, where C<TAG> is the tag name, C<xx> is a 2-character lower
         case ISO 639-1 language code, and C<YY> is a 2-character upper case ISO
-        3166-1 alpha 2 country code (ie. C<Title-en_US>).  But as usual, the user
+        3166-1 alpha 2 country code (eg. C<Title-en_US>).  But as usual, the user
         interface is case-insensitive, and ExifTool will write the correct case to
         the file.
@@ -150,6 +150,12 @@
         3) Some numerical MIE tags allow units of measurement to be specified.  For
         these tags, units may be added in brackets immediately following the value
-        (ie. C<55(mi/h)>).  If no units are specified, the default units are
+        (eg. C<55(mi/h)>).  If no units are specified, the default units are
         written.
+
+        4) ExifTool writes compressed metadata to MIE files if the L<Compress|../ExifTool.html#Compress> (-z)
+        option is used and Compress::Zlib is available.
+
+        See L<https://exiftool.org/MIE1.1-20070121.pdf> for the official MIE
+        specification.
     },
    '0Type' => {
@@ -296,5 +302,5 @@
     Copyright   => { Groups => { 2 => 'Author' } },
     CreateDate  => { Groups => { 2 => 'Time' }, %dateInfo },
-    EMail       => { Groups => { 2 => 'Author' } },
+    EMail       => { Name => 'Email', Groups => { 2 => 'Author' } },
     Keywords    => { List => 1 },
     ModifyDate  => { Groups => { 2 => 'Time' }, %dateInfo },
@@ -464,4 +470,5 @@
     data => {
         Name => 'FullSizeImage',
+        Groups => { 2 => 'Preview' },
         %binaryConv,
         RawConv => '$self->ValidateImage(\$val,$tag)',
@@ -486,4 +493,5 @@
     data => {
         Name => 'PreviewImage',
+        Groups => { 2 => 'Preview' },
         %binaryConv,
         RawConv => '$self->ValidateImage(\$val,$tag)',
@@ -508,4 +516,5 @@
     data => {
         Name => 'ThumbnailImage',
+        Groups => { 2 => 'Preview' },
         %binaryConv,
         RawConv => '$self->ValidateImage(\$val,$tag)',
@@ -565,5 +574,5 @@
         Writable => 'rational64u',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
-        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+        PrintConvInv => '$val',
     },
     Flash => {
@@ -782,5 +791,5 @@
 #------------------------------------------------------------------------------
 # Get localized version of tagInfo hash
-# Inputs: 0) tagInfo hash ref, 1) locale code (ie. "en_CA")
+# Inputs: 0) tagInfo hash ref, 1) locale code (eg. "en_CA")
 # Returns: new tagInfo hash ref, or undef if invalid
 sub GetLangInfo($$)
@@ -803,5 +812,5 @@
 {
     unless (defined $hasZlib) {
-        $hasZlib = eval 'require Compress::Zlib';
+        $hasZlib = eval { require Compress::Zlib };
         unless ($hasZlib) {
             $hasZlib = 0;
@@ -827,11 +836,11 @@
 # Inputs: 0) data reference, 1) value offset, 2) format string,
 #         3) number of values (or undef to use all data)
-#         4) valid data length relative to offset
+#         4) valid data length relative to offset, 5) returned rational ref
 # Returns: converted value, or undefined if data isn't there
 #          or list of values in list context
 # Notes: all string formats are converted to UTF8
-sub ReadMIEValue($$$$$)
+sub ReadMIEValue($$$$$;$)
 {
-    my ($dataPt, $offset, $format, $count, $size) = @_;
+    my ($dataPt, $offset, $format, $count, $size, $ratPt) = @_;
     my $val;
     if ($format =~ /^(utf(8|16|32)|string)/) {
@@ -860,5 +869,5 @@
     } else {
         $format = 'undef' if $format eq 'free'; # read 'free' as 'undef'
-        return ReadValue($dataPt, $offset, $format, $count, $size);
+        return ReadValue($dataPt, $offset, $format, $count, $size, $ratPt);
     }
     return $val;
@@ -871,5 +880,5 @@
 sub CheckMIE($$$)
 {
-    my ($exifTool, $tagInfo, $valPtr) = @_;
+    my ($et, $tagInfo, $valPtr) = @_;
     my $format = $$tagInfo{Writable} || $tagInfo->{Table}->{WRITABLE};
     my $err;
@@ -888,9 +897,9 @@
         return 'Units not supported';
     } else {
-        if ($format eq 'string' and $exifTool->{OPTIONS}->{Charset} ne 'UTF8' and
+        if ($format eq 'string' and $$et{OPTIONS}{Charset} ne 'UTF8' and
             $$valPtr =~ /[\x80-\xff]/)
         {
             # convert from Charset to UTF-8
-            $$valPtr = $exifTool->Encode($$valPtr,'UTF8');
+            $$valPtr = $et->Encode($$valPtr,'UTF8');
         }
         $err = Image::ExifTool::CheckValue($valPtr, $format, $$tagInfo{Count});
@@ -905,12 +914,12 @@
 sub WriteMIEGroup($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $outfile = $$dirInfo{OutFile};
     my $dirName = $$dirInfo{DirName};
     my $toWrite = $$dirInfo{ToWrite} || '';
     my $raf = $$dirInfo{RAF};
-    my $verbose = $exifTool->Options('Verbose');
-    my $optCompress = $exifTool->Options('Compress');
-    my $out = $exifTool->Options('TextOut');
+    my $verbose = $et->Options('Verbose');
+    my $optCompress = $et->Options('Compress');
+    my $out = $et->Options('TextOut');
     my ($msg, $err, $ok, $sync, $delGroup);
     my $tag = '';
@@ -919,5 +928,5 @@
     # count each MIE directory found and make name for this specific instance
     my ($grp1, %isWriting);
-    my $cnt = $exifTool->{MIE_COUNT};
+    my $cnt = $$et{MIE_COUNT};
     my $grp = $tagTablePtr->{GROUPS}->{1};
     my $n = $$cnt{'MIE-Main'} || 0;
@@ -928,24 +937,24 @@
         ($grp1 = $grp) =~ s/MIE-/MIE$n-/;
         my $m = $$cnt{$grp1} = ($$cnt{$grp1} || 0) + 1;
-        $isWriting{"$grp$m"} = 1;   # ie. 'MIE-Doc2'
-        $isWriting{$grp1} = 1;      # ie. 'MIE1-Doc'
+        $isWriting{"$grp$m"} = 1;   # eg. 'MIE-Doc2'
+        $isWriting{$grp1} = 1;      # eg. 'MIE1-Doc'
         $grp1 .= $m;
     }
     # build lookup for all valid group names for this MIE group
-    $isWriting{$grp} = 1;           # ie. 'MIE-Doc'
-    $isWriting{$grp1} = 1;          # ie. 'MIE1-Doc2'
-    $isWriting{"MIE$n"} = 1;        # ie. 'MIE1'
+    $isWriting{$grp} = 1;           # eg. 'MIE-Doc'
+    $isWriting{$grp1} = 1;          # eg. 'MIE1-Doc2'
+    $isWriting{"MIE$n"} = 1;        # eg. 'MIE1'
 
     # determine if we are deleting this group
-    if (%{$exifTool->{DEL_GROUP}}) {
-        $delGroup = 1 if $exifTool->{DEL_GROUP}->{MIE} or
-                         $exifTool->{DEL_GROUP}->{$grp} or
-                         $exifTool->{DEL_GROUP}->{$grp1} or
-                         $exifTool->{DEL_GROUP}->{"MIE$n"};
+    if (%{$$et{DEL_GROUP}}) {
+        $delGroup = 1 if $$et{DEL_GROUP}{MIE} or
+                         $$et{DEL_GROUP}{$grp} or
+                         $$et{DEL_GROUP}{$grp1} or
+                         $$et{DEL_GROUP}{"MIE$n"};
     }
 
     # prepare lookups and lists for writing
-    my $newTags = $exifTool->GetNewTagInfoHash($tagTablePtr);
-    my ($addDirs, $editDirs) = $exifTool->GetAddDirHash($tagTablePtr, $dirName);
+    my $newTags = $et->GetNewTagInfoHash($tagTablePtr);
+    my ($addDirs, $editDirs) = $et->GetAddDirHash($tagTablePtr, $dirName);
     my @editTags = sort keys %$newTags, keys %$editDirs;
     $verbose and print $out $raf ? 'Writing' : 'Creating', " $grp1:\n";
@@ -972,5 +981,5 @@
                 $raf->Read($tag, $tagLen) == $tagLen or last;
                 $oldHdr .= $tag;    # add tag to element header
-                $exifTool->Warn("MIE tag '$tag' out of sequence") if $tag lt $lastTag;
+                $et->Warn("MIE tag '${tag}' out of sequence") if $tag lt $lastTag;
                 # separate units from tag name if they exist
                 $units = $1 if $tag =~ s/\((.*)\)$//;
@@ -993,11 +1002,11 @@
             }
             # don't rewrite free bytes or information in deleted groups
-            if ($format eq 0x80 or ($delGroup and $tagLen and ($format & 0xf0) != 0x10)) {
+            if ($format == 0x80 or ($delGroup and $tagLen and ($format & 0xf0) != 0x10)) {
                 $raf->Seek($valLen, 1) or $msg = 'Seek error', last;
                 if ($verbose > 1) {
-                    my $free = ($format eq 0x80) ? ' free' : '';
+                    my $free = ($format == 0x80) ? ' free' : '';
                     print $out "    - $grp1:$tag ($valLen$free bytes)\n";
                 }
-                ++$exifTool->{CHANGED} if $delGroup;
+                ++$$et{CHANGED} if $delGroup;
                 next;
             }
@@ -1020,5 +1029,5 @@
                 my $subTablePtr = GetTagTable($newInfo->{SubDirectory}->{TagTable});
                 unless ($subTablePtr) {
-                    $exifTool->Warn("No tag table for $newTag $$newInfo{Name}");
+                    $et->Warn("No tag table for $newTag $$newInfo{Name}");
                     next;
                 }
@@ -1030,10 +1039,10 @@
                     # make sure that either both or neither old and new tags are MIE groups
                     if ($isMieGroup xor ($format & 0xf3) == 0x10) {
-                        $exifTool->Warn("Tag '$tag' not expected type");
+                        $et->Warn("Tag '${tag}' not expected type");
                         next;   # don't write our new tag
                     }
                     # uncompress existing directory into $oldVal since we are editing it
                     if ($format & 0x04) {
-                        last unless HasZlib($exifTool, 'edit');
+                        last unless HasZlib($et, 'edit');
                         $raf->Read($oldVal, $valLen) == $valLen or last MieElement;
                         my $stat;
@@ -1080,6 +1089,6 @@
                     $subdirInfo{Parent} = $dirName;
                     # don't compress elements of an already compressed group
-                    $subdirInfo{IsCompressed} = 1;
-                    $msg = WriteMIEGroup($exifTool, \%subdirInfo, $subTablePtr);
+                    $subdirInfo{IsCompressed} = $$dirInfo{IsCompressed} || $compress;
+                    $msg = WriteMIEGroup($et, \%subdirInfo, $subTablePtr);
                     last MieElement if $msg;
                     # message is defined but empty if nothing was written
@@ -1091,4 +1100,8 @@
                         $toWrite = '';
                         next;
+                    } elsif (length($newVal) <= 4) {    # terminator only?
+                        $verbose and print $out "Deleted compressed $grp1 (empty)\n";
+                        next MieElement if $newTag eq $tag; # deleting the directory
+                        next;       # not creating the new directory
                     }
                     $writable = 'undef';
@@ -1104,5 +1117,5 @@
                             DataLen => $valLen,
                             DirName => $$newInfo{Name},
-                            DataPos => $raf->Tell() - $valLen,
+                            DataPos => $$dirInfo{IsCompressed} ? undef : $raf->Tell() - $valLen,
                             DirStart=> 0,
                             DirLen  => $valLen,
@@ -1110,7 +1123,8 @@
                         # write Compact subdirectories if we will compress the data
                         if (($compress or $optCompress or $$dirInfo{IsCompressed}) and
-                            eval 'require Compress::Zlib')
+                            eval { require Compress::Zlib })
                         {
                             $subdirInfo{Compact} = 1;
+                            $subdirInfo{ReadOnly} = 1;  # because XMP is not writable in place
                         }
                     }
@@ -1118,6 +1132,6 @@
                     my $writeProc = $newInfo->{SubDirectory}->{WriteProc};
                     # reset processed lookup to avoid errors in case of multiple EXIF blocks
-                    $exifTool->{PROCESSED} = { };
-                    $newVal = $exifTool->WriteDirectory(\%subdirInfo, $subTablePtr, $writeProc);
+                    $$et{PROCESSED} = { };
+                    $newVal = $et->WriteDirectory(\%subdirInfo, $subTablePtr, $writeProc);
                     if (defined $newVal) {
                         if ($newVal eq '') {
@@ -1136,5 +1150,5 @@
                 # get the new tag information
                 $newInfo = $$newTags{$newTag};
-                my $nvHash = $exifTool->GetNewValueHash($newInfo);
+                my $nvHash = $et->GetNewValueHash($newInfo);
                 my @newVals;
 
@@ -1148,7 +1162,8 @@
                     my $isList = $$newInfo{List};
                     if ($isList) {
+                        last if $$nvHash{CreateOnly};
                         $isOverwriting = -1;    # force processing list elements individually
                     } else {
-                        $isOverwriting = Image::ExifTool::IsOverwriting($nvHash);
+                        $isOverwriting = $et->IsOverwriting($nvHash);
                         last unless $isOverwriting;
                     }
@@ -1156,5 +1171,5 @@
                     if ($isOverwriting < 0 or $verbose > 1) {
                         # check to be sure we can uncompress the value if necessary
-                        HasZlib($exifTool, 'edit') or last if $format & 0x04;
+                        HasZlib($et, 'edit') or last if $format & 0x04;
                         # read the old value
                         $raf->Read($oldVal, $valLen) == $valLen or last MieElement;
@@ -1187,10 +1202,10 @@
                                 # keep any list items that we aren't overwriting
                                 foreach $v (@vals) {
-                                    next if Image::ExifTool::IsOverwriting($nvHash, $v);
+                                    next if $et->IsOverwriting($nvHash, $v);
                                     push @newVals, $v;
                                 }
                             } else {
                                 # test to see if we really want to overwrite the value
-                                $isOverwriting = Image::ExifTool::IsOverwriting($nvHash, $val);
+                                $isOverwriting = $et->IsOverwriting($nvHash, $val);
                             }
                         }
@@ -1203,8 +1218,8 @@
                         if ($verbose > 1) {
                             $val .= "($units)" if defined $units;
-                            $exifTool->VerboseValue("- $grp1:$$newInfo{Name}", $val);
+                            $et->VerboseValue("- $grp1:$$newInfo{Name}", $val);
                         }
                         $deletedTag = $tag;     # remember that we deleted this tag
-                        ++$exifTool->{CHANGED}; # we deleted the old value
+                        ++$$et{CHANGED}; # we deleted the old value
                     } else {
                         if (defined $oldVal) {
@@ -1217,4 +1232,5 @@
                         Write($outfile, $toWrite, $oldHdr, $oldVal) or $err = 1;
                         $toWrite = '';
+                        next MieElement;
                     }
                     unless (@newVals) {
@@ -1226,9 +1242,9 @@
                     # write new value if creating, or if List and list existed, or
                     # if tag was previously deleted
-                    next unless Image::ExifTool::IsCreating($nvHash) or
+                    next unless $$nvHash{IsCreating} or
                         ($newTag eq $lastTag and ($$newInfo{List} or $deletedTag eq $lastTag));
                 }
                 # get the new value to write (undef to delete)
-                push @newVals, Image::ExifTool::GetNewValues($nvHash);
+                push @newVals, $et->GetNewValue($nvHash);
                 next unless @newVals;
                 $writable = $$newInfo{Writable} || $$tagTablePtr{WRITABLE};
@@ -1257,5 +1273,5 @@
                 $newFormat = $mieCode{$writable};
                 unless (defined $newFormat) {
-                    $msg = "Bad format '$writable' for $$newInfo{Name}";
+                    $msg = "Bad format '${writable}' for $$newInfo{Name}";
                     next MieElement;
                 }
@@ -1283,5 +1299,5 @@
                 if ($writable !~ /^(utf|string|undef)/) {
                     my $val3 = WriteValue($$valPt, $writable, $$newInfo{Count});
-                    defined $val3 or $exifTool->Warn("Error writing $newTag"), last;
+                    defined $val3 or $et->Warn("Error writing $newTag"), last;
                     $valPt = \$val3;
                 }
@@ -1289,5 +1305,5 @@
                 # compress value before writing if required
                 if (($compress or $optCompress) and not $$dirInfo{IsCompressed} and
-                    HasZlib($exifTool, 'write'))
+                    HasZlib($et, 'write'))
                 {
                     my $deflate = Compress::Zlib::deflateInit();
@@ -1310,5 +1326,5 @@
                         }
                     } else {
-                        $exifTool->Warn("Error deflating $newTag (written uncompressed)");
+                        $et->Warn("Error deflating $newTag (written uncompressed)");
                     }
                 }
@@ -1324,5 +1340,5 @@
                     $len = 254;
                 } else {
-                    $exifTool->Warn("Can't write $newTag (DataLength > 2GB not yet suppported)");
+                    $et->Warn("Can't write $newTag (DataLength > 2GB not yet supported)");
                     last; # don't write this tag
                 }
@@ -1333,6 +1349,6 @@
                 # we changed a tag unless just editing a subdirectory
                 unless ($$editDirs{$newTag}) {
-                    $exifTool->VerboseValue("+ $grp1:$$newInfo{Name}", $newVal);
-                    ++$exifTool->{CHANGED};
+                    $et->VerboseValue("+ $grp1:$$newInfo{Name}", $newVal);
+                    ++$$et{CHANGED};
                 }
                 last;   # didn't want to loop anyway
@@ -1368,5 +1384,5 @@
         if ($format == 0x10 or $format == 0x18) {
             my ($subTablePtr, $dirName);
-            my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+            my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
             if ($tagInfo and $$tagInfo{SubDirectory}) {
                 $dirName = $tagInfo->{SubDirectory}->{DirName};
@@ -1387,5 +1403,5 @@
             my $oldOrder = GetByteOrder();
             SetByteOrder($format & 0x08 ? 'II' : 'MM');
-            $msg = WriteMIEGroup($exifTool, \%subdirInfo, $subTablePtr);
+            $msg = WriteMIEGroup($et, \%subdirInfo, $subTablePtr);
             SetByteOrder($oldOrder);
             last if $msg;
@@ -1425,15 +1441,15 @@
 sub ProcessMIEGroup($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $raf = $$dirInfo{RAF};
-    my $verbose = $exifTool->Options('Verbose');
-    my $out = $exifTool->Options('TextOut');
-    my $notUTF8 = ($exifTool->{OPTIONS}->{Charset} ne 'UTF8');
+    my $verbose = $et->Options('Verbose');
+    my $out = $et->Options('TextOut');
+    my $notUTF8 = ($$et{OPTIONS}{Charset} ne 'UTF8');
     my ($msg, $buff, $ok, $oldIndent, $mime);
     my $lastTag = '';
 
-    # get group 1 names: $grp doesn't have numbers (ie. 'MIE-Doc'),
-    # and $grp1 does (ie. 'MIE1-Doc1')
-    my $cnt = $exifTool->{MIE_COUNT};
+    # get group 1 names: $grp doesn't have numbers (eg. 'MIE-Doc'),
+    # and $grp1 does (eg. 'MIE1-Doc1')
+    my $cnt = $$et{MIE_COUNT};
     my $grp1 = $tagTablePtr->{GROUPS}->{1};
     my $n = $$cnt{'MIE-Main'} || 0;
@@ -1447,10 +1463,10 @@
     }
     # set group1 name for all tags extracted from this group
-    $exifTool->{SET_GROUP1} = $grp1;
+    $$et{SET_GROUP1} = $grp1;
 
     if ($verbose) {
-        $oldIndent = $exifTool->{INDENT};
-        $exifTool->{INDENT} .= '| ';
-        $exifTool->VerboseDir($grp1);
+        $oldIndent = $$et{INDENT};
+        $$et{INDENT} .= '| ';
+        $et->VerboseDir($grp1);
     }
     my $wasCompressed = $$dirInfo{WasCompressed};
@@ -1466,5 +1482,5 @@
         if ($tagLen) {
             $raf->Read($tag, $tagLen) == $tagLen or last;
-            $exifTool->Warn("MIE tag '$tag' out of sequence") if $tag lt $lastTag;
+            $et->Warn("MIE tag '${tag}' out of sequence") if $tag lt $lastTag;
             $lastTag = $tag;
             # separate units from tag name if they exist
@@ -1496,5 +1512,5 @@
         my ($tagInfo, $value);
         while ($format != 0x80) {
-            $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tag);
+            $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
             last if $tagInfo;
             # extract tags with locale code
@@ -1502,9 +1518,9 @@
                 if ($tag =~ /^(\w+)-([a-z]{2}_[A-Z]{2})$/) {
                     my ($baseTag, $langCode) = ($1, $2);
-                    $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $baseTag);
+                    $tagInfo = $et->GetTagInfo($tagTablePtr, $baseTag);
                     $tagInfo = GetLangInfo($tagInfo, $langCode) if $tagInfo;
                     last if $tagInfo;
                 } else {
-                    $exifTool->Warn('Invalid MIE tag name');
+                    $et->Warn('Invalid MIE tag name');
                     last;
                 }
@@ -1516,5 +1532,5 @@
                 PrintConv => 'length($val) > 60 ? substr($val,0,55) . "[...]" : $val',
             };
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, $tagInfo);
+            AddTagToTable($tagTablePtr, $tag, $tagInfo);
             last;
         }
@@ -1526,12 +1542,12 @@
             if ($format & 0x04) {
                 if ($verbose) {
-                    print $out "$$exifTool{INDENT}\[Tag '$tag' $valLen bytes compressed]\n";
+                    print $out "$$et{INDENT}\[Tag '${tag}' $valLen bytes compressed]\n";
                 }
-                next unless HasZlib($exifTool, 'decode');
+                next unless HasZlib($et, 'decode');
                 my $stat;
                 my $inflate = Compress::Zlib::inflateInit();
                 $inflate and ($value, $stat) = $inflate->inflate($value);
                 unless ($inflate and $stat == Compress::Zlib::Z_STREAM_END()) {
-                    $exifTool->Warn("Error inflating $tag");
+                    $et->Warn("Error inflating $tag");
                     next;
                 }
@@ -1554,5 +1570,5 @@
             if ($verbose) {
                 my $order = ', byte order ' . GetByteOrder();
-                $exifTool->VerboseInfo($tag, $tagInfo, Size => $valLen, Extra => $order);
+                $et->VerboseInfo($tag, $tagInfo, Size => $valLen, Extra => $order);
             }
             my %subdirInfo = (
@@ -1563,19 +1579,20 @@
             );
             # read from uncompressed data instead if necessary
-            $subdirInfo{RAF} = new File::RandomAccess(\$value) if $format & 0x04;
+            $subdirInfo{RAF} = new File::RandomAccess(\$value) if $valLen;
 
             my $oldOrder = GetByteOrder();
             SetByteOrder($format & 0x08 ? 'II' : 'MM');
-            $msg = ProcessMIEGroup($exifTool, \%subdirInfo, $subTablePtr);
+            $msg = ProcessMIEGroup($et, \%subdirInfo, $subTablePtr);
             SetByteOrder($oldOrder);
-            $exifTool->{SET_GROUP1} = $grp1;    # restore this group1 name
+            $$et{SET_GROUP1} = $grp1;    # restore this group1 name
             last if $msg;
         } else {
             # process MIE data format types
             if ($tagInfo) {
+                my $rational;
                 # extract tag value
-                my $val = ReadMIEValue(\$value, 0, $formatStr, undef, $valLen);
+                my $val = ReadMIEValue(\$value, 0, $formatStr, undef, $valLen, \$rational);
                 unless (defined $val) {
-                    $exifTool->Warn("Error reading $tag value");
+                    $et->Warn("Error reading $tag value");
                     $val = '<err>';
                 }
@@ -1588,7 +1605,7 @@
                         $count = $valLen / $s;
                     }
-                    $exifTool->VerboseInfo($lastTag, $tagInfo,
+                    $et->VerboseInfo($lastTag, $tagInfo,
                         DataPt  => \$value,
-                        DataPos => $raf->Tell() - $valLen,
+                        DataPos => $wasCompressed ? undef : $raf->Tell() - $valLen,
                         Size    => $valLen,
                         Format  => $formatStr,
@@ -1610,20 +1627,20 @@
                     # set DataPos and Base for uncompressed information only
                     unless ($wasCompressed) {
-                        $subdirInfo{DataPos} = $raf->Tell() - $valLen;
+                        $subdirInfo{DataPos} = 0; # (relative to Base)
                         $subdirInfo{Base}    = $raf->Tell() - $valLen;
                     }
                     # reset PROCESSED lookup for each MIE directory
                     # (there is no possibility of double-processing a MIE directory)
-                    $exifTool->{PROCESSED} = { };
+                    $$et{PROCESSED} = { };
                     my $processProc = $tagInfo->{SubDirectory}->{ProcessProc};
-                    delete $exifTool->{SET_GROUP1};
-                    delete $exifTool->{NO_LIST};
-                    $exifTool->ProcessDirectory(\%subdirInfo, $subTablePtr, $processProc);
-                    $exifTool->{SET_GROUP1} = $grp1;
-                    $exifTool->{NO_LIST} = 1;
+                    delete $$et{SET_GROUP1};
+                    delete $$et{NO_LIST};
+                    $et->ProcessDirectory(\%subdirInfo, $subTablePtr, $processProc);
+                    $$et{SET_GROUP1} = $grp1;
+                    $$et{NO_LIST} = 1;
                 } else {
                     # convert to specified character set if necessary
                     if ($notUTF8 and $formatStr =~ /^(utf|string)/) {
-                        $val = $exifTool->Decode($val, 'UTF8');
+                        $val = $et->Decode($val, 'UTF8');
                     }
                     if ($formatStr =~ /_list$/) {
@@ -1637,18 +1654,19 @@
                         $val .= "($units)" if defined $units;
                     }
-                    $exifTool->FoundTag($tagInfo, $val);
+                    my $key = $et->FoundTag($tagInfo, $val);
+                    $$et{RATIONAL}{$key} = $rational if defined $rational and defined $key;
                 }
             } else {
                 # skip over unknown information or free bytes
                 $raf->Seek($valLen, 1) or $msg = 'Seek error', last;
-                $verbose and $exifTool->VerboseInfo($tag, undef, Size => $valLen);
+                $verbose and $et->VerboseInfo($tag, undef, Size => $valLen);
             }
         }
     }
     # modify MIME type if necessary
-    $mime and not $$dirInfo{Parent} and $exifTool->ModifyMimeType($mime);
+    $mime and not $$dirInfo{Parent} and $et->ModifyMimeType($mime);
 
     $ok or $msg or $msg = 'Unexpected end of file';
-    $verbose and $exifTool->{INDENT} = $oldIndent;
+    $verbose and $$et{INDENT} = $oldIndent;
     return $msg;
 }
@@ -1661,6 +1679,6 @@
 sub ProcessMIE($$)
 {
-    my ($exifTool, $dirInfo) = @_;
-    return 1 unless defined $exifTool;
+    my ($et, $dirInfo) = @_;
+    return 1 unless defined $et;
     my $raf = $$dirInfo{RAF};
     my $outfile = $$dirInfo{OutFile};
@@ -1699,11 +1717,11 @@
         $$dirInfo{DataPos} = $pos;
         $$dirInfo{DirLen} = $end - $pos;
-        if ($outfile and $exifTool->{DEL_GROUP}->{MIE}) {
+        if ($outfile and $$et{DEL_GROUP}{MIE}) {
             # delete the trailer
-            $exifTool->VPrint(0,"  Deleting MIE trailer\n");
-            ++$exifTool->{CHANGED};
+            $et->VPrint(0,"  Deleting MIE trailer\n");
+            ++$$et{CHANGED};
             return 1;
-        } elsif ($exifTool->Options('Verbose') or $exifTool->{HTML_DUMP}) {
-            $exifTool->DumpTrailer($dirInfo);
+        } elsif ($et->Options('Verbose') or $$et{HTML_DUMP}) {
+            $et->DumpTrailer($dirInfo);
         }
     }
@@ -1716,5 +1734,5 @@
         if ($num == 8) {
             # verify file identifier
-            if ($buff =~ /^~(\x10|\x18)\x04(.)0MIE/) {
+            if ($buff =~ /^~(\x10|\x18)\x04(.)0MIE/s) {
                 SetByteOrder($1 eq "\x10" ? 'MM' : 'II');
                 my $len = ord($2);
@@ -1740,5 +1758,5 @@
             $buff = ''; # start from nothing
             # set byte order according to preferences
-            $exifTool->SetPreferredByteOrder();
+            $et->SetPreferredByteOrder();
             $isCreating = 1;
         }
@@ -1746,7 +1764,7 @@
             last if $$dirInfo{Trailer}; # allow other trailers after MIE
             if ($outfile) {
-                $exifTool->Error($msg);
+                $et->Error($msg);
             } else {
-                $exifTool->Warn($msg);
+                $et->Warn($msg);
             }
             last;
@@ -1755,7 +1773,7 @@
         unless ($numDocs) {
             # this is a valid MIE file (unless a trailer on another file)
-            $exifTool->SetFileType();
-            $exifTool->{NO_LIST} = 1;   # handle lists ourself
-            $exifTool->{MIE_COUNT} = { };
+            $et->SetFileType();
+            $$et{NO_LIST} = 1;   # handle lists ourself
+            $$et{MIE_COUNT} = { };
             undef $hasZlib;
         }
@@ -1784,9 +1802,9 @@
             #  to another type of image, but this is OK because we are done writing
             #  the other format by the time we start writing the trailer)
-            $exifTool->InitWriteDirs(\%mieMap, 'MIE');
+            $et->InitWriteDirs(\%mieMap, 'MIE');
             $subdirInfo{ToWrite} = '~' . MIEGroupFormat(1) . "\x04\xfe0MIE\0\0\0\0";
-            $msg = WriteMIEGroup($exifTool, \%subdirInfo, $tagTablePtr);
+            $msg = WriteMIEGroup($et, \%subdirInfo, $tagTablePtr);
             if ($msg) {
-                $exifTool->Error($msg);
+                $et->Error($msg);
                 $err = 1;
                 last;
@@ -1795,14 +1813,14 @@
             }
         } else {
-            $msg = ProcessMIEGroup($exifTool, \%subdirInfo, $tagTablePtr);
+            $msg = ProcessMIEGroup($et, \%subdirInfo, $tagTablePtr);
             if ($msg) {
-                $exifTool->Warn($msg);
+                $et->Warn($msg);
                 last;
             }
         }
     }
-    delete $exifTool->{NO_LIST};
-    delete $exifTool->{MIE_COUNT};
-    delete $exifTool->{SET_GROUP1};
+    delete $$et{NO_LIST};
+    delete $$et{MIE_COUNT};
+    delete $$et{SET_GROUP1};
     return $err ? -1 : 1;
 }
@@ -1852,5 +1870,5 @@
  12) Relocatable data elements (ie. no fixed offsets).
  13) Binary meta information (+7) with variable byte order (+3).
- 14) Mandatory tags not required (an unecessary complication).
+ 14) Mandatory tags not required (an unnecessary complication).
  15) Append information to end of file without editing.
 
@@ -2059,5 +2077,5 @@
 
 The TagName of a string element may have an 6-character suffix to indicate a
-specific locale. (ie. "Title-en_US", or "Keywords-de_DE").
+specific locale. (eg. "Title-en_US", or "Keywords-de_DE").
 
 =item 3.
